declare @cStatement varchar(500)	/* Value from the t_cursor */
declare @ColumnCount int		/* Counter for # columns on current line */
declare @NumColumnBlocks int 		/* Total # of columns to print per line */
declare @FirstTime int			/* First time through print loop */
declare @TableName char(255)		/* Table whose columns will be listed */
declare @PrintString char(500)		/* Used to build up the print line */
declare @ColumnType int

set nocount on
select @TableName = 'SOP10100'		/* Name of table */
select @NumColumnBlocks = 4	/* How many columns to have per line */

declare T_cursor cursor for
  select c.name,c.xtype from syscolumns c, sysobjects o
    where o.name = @TableName  and o.id = c.id

/*  Ok, we have the list of column names.  Now string them together in a comma
    separated list.  Leave out the DEX_ROW_ID column. */

select @ColumnCount = 0
select @PrintString = ''
select @FirstTime = 1

set nocount on
open T_cursor
fetch next from T_cursor into @cStatement,@ColumnType 
while (@@fetch_status <> -1)
  begin
  if (@cStatement <> 'DEX_ROW_ID')
    begin
    if (@FirstTime = 1)
      begin
      if (@ColumnType = 175) begin
        select @PrintString = 'select ''Insert into ' + rtrim(@TableName) + ' values ('''''''
        print rtrim(@PrintString)
        select @PrintString = '  +rtrim(' + @cStatement + ')+'''''''
        end
      else if (@ColumnType = 61) begin
        select @PrintString = 'select ''Insert into ' + rtrim(@TableName) + ' values ('''''''
        print rtrim(@PrintString)
        select @PrintString = '  +cast(' + @cStatement+ ' as varchar)+'''''''
        end
      else begin
        select @PrintString = 'select ''Insert into ' + rtrim(@TableName) + ' values ('''
        print rtrim(@PrintString)
        select @PrintString = '  +cast(' + @cStatement+ ' as varchar)+'''
        end
      select @FirstTime = 0
      end
    else
      begin
      select @PrintString = rtrim(@PrintString) + ','''
      if (@ColumnCount = @NumColumnBlocks)
        begin
        print rtrim(@PrintString)
        select @ColumnCount = 0
        select @PrintString = ''
        end
      if (@ColumnCount = 0) begin
        if (@ColumnType = 175) select @PrintString = rtrim(@PrintString) + '  +''''''''+rtrim(' + @cStatement + ')+'''''''
        else if (@ColumnType = 61) select @PrintString = rtrim(@PrintString) + '  +''''''''+cast(' + @cStatement+ ' as varchar)+'''''''
        else select @PrintString = rtrim(@PrintString) + '  +cast(' + @cStatement+ ' as varchar)+'''
        end
      else begin
        if (@ColumnType = 175) select @PrintString = rtrim(@PrintString) + '''''+rtrim(' + @cStatement + ')+'''''''
        else if (@ColumnType = 61) select @PrintString = rtrim(@PrintString) + '''''+cast(' + @cStatement+ ' as varchar)+'''''''
        else select @PrintString = rtrim(@PrintString) + '+cast(' + @cStatement+ ' as varchar)+'''
        end
      end
    select @ColumnCount = @ColumnCount + 1
    end
  fetch next from T_cursor into @cStatement,@ColumnType 
  end
deallocate T_cursor

/* Print the remaining columns. */
select @PrintString = rtrim(@PrintString) + ')'''
print rtrim(@PrintString)
select @PrintString = 'from ' + rtrim(@TableName)
print rtrim(@PrintString)
set nocount off
