/******************  Set AX Client tracing *************/
/* NOTE: must enable AX client tracing on the AOS servers */

USE DynamicsPerf

EXEC SET_AX_SQLTRACE
  @DATABASE_NAME = 'MicrosoftDynamicsAX',
  @QUERY_TIME_LIMIT = 2000
  
  --NOTE:  Setting @QUERY_TIME_LIMIT too low could casue performance issues
  
  
  GO

/**************** Disable AX client tracing ****************/


USE DynamicsPerf

EXEC SET_AX_SQLTRACE
  @DATABASE_NAME = 'XXXXXXX',
  @TRACE_STATUS = 'OFF' 
